import { Database } from 'sqlite3';
import { Db, IOp, ICommitSnapshot, ISnapshot, IDocument, ISnapshotFragments } from "@grapecity/js-collaboration-ot";

export declare class SqliteDb<S = unknown, T = unknown> extends Db<S, T> {
    constructor(db: Database);

    getDocument(roomId: string): Promise<IDocument | undefined>;
    getSnapshot(roomId: string): Promise<ISnapshot<S> | undefined>;
    getFragment(roomId: string, fragmentId: string): Promise<S | undefined>;
    getFragments(roomId: string): Promise<ISnapshotFragments<S>>;
    getOps(roomId: string, fromVersion: number, toVersion?: number): Promise<IOp<T>[]>;
    commitOp(id: string, op: IOp<T>, document: IDocument): Promise<boolean>;
    commitSnapshot(roomId: string, snapshot: ICommitSnapshot<S>): Promise<boolean>;
    close(): Promise<void>;
}
